=== debian/changelog ===
pcm (202201-1) unstable; urgency=medium

  * New upstream release.
  * Upstream build system changed to cmake.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 03 Feb 2022 14:01:20 +0100

pcm (202112-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 29 Dec 2021 18:07:16 +0100

pcm (202110-1) unstable; urgency=medium

  * New upstream release.
  * Fill in version.h
  * Add libsimdjson-dev to B-Deps.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 10 Nov 2021 19:47:27 +0100

pcm (202107-1) experimental; urgency=medium

  * Initial release (Closes: #987235)

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 30 Aug 2021 09:47:10 +0200
