=== debian/changelog ===
pcm (202207-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 22 Jul 2022 17:48:12 +0200

pcm (202205-1) unstable; urgency=medium

  * New upstream release.
  * Use system simdjson.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 18 May 2022 13:19:15 +0200

pcm (202203-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 29 Mar 2022 14:41:43 +0200

pcm (202202-1) unstable; urgency=medium

  * New upstream release.
  * Don't install superfluous license files.
  * Don't call dpkg-parsechangelog ourselves.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 07 Mar 2022 13:13:52 +0100
