=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
-Build-Depends: debhelper-compat (= 13), libsimdjson-dev, cmake
-Standards-Version: 4.6.0
+Build-Depends: debhelper-compat (= 13), libsimdjson-dev, cmake, libsimdjson-dev
+Standards-Version: 4.6.1
 Homepage: https://github.com/opcm/pcm
 Vcs-Browser: https://github.com/kilobyte/pcm
 Vcs-Git: https://github.com/kilobyte/pcm
