## pcm 202302

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,18 +3,22 @@
 
 
 # All pcm-* executables
-set(PROJECT_NAMES pcm pcm-numa pcm-latency pcm-power pcm-msr pcm-memory pcm-tsx pcm-pcie pcm-core pcm-iio pcm-lspci pcm-pcicfg pcm-mmio pcm-raw)
-
-file(GLOB COMMON_SOURCES msr.cpp cpucounters.cpp pci.cpp mmio.cpp bw.cpp utils.cpp topology.cpp debug.cpp threadpool.cpp)
-file(GLOB UNUX_SOURCES dashboard.cpp resctrl.cpp)
+set(PROJECT_NAMES pcm pcm-numa pcm-latency pcm-power pcm-msr pcm-memory pcm-tsx pcm-pcie pcm-core pcm-iio pcm-lspci pcm-pcicfg pcm-mmio pcm-raw pcm-accel)
+
+file(GLOB COMMON_SOURCES msr.cpp cpucounters.cpp pci.cpp mmio.cpp bw.cpp utils.cpp topology.cpp debug.cpp threadpool.cpp uncore_pmu_discovery.cpp)
+
+if (APPLE)
+  file(GLOB UNUX_SOURCES dashboard.cpp)
+else()
+  file(GLOB UNUX_SOURCES dashboard.cpp resctrl.cpp)
+endif()
 
 if(UNIX)  # LINUX, FREE_BSD, APPLE
-    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS} -s")  # --strip-unneeded for packaging
-
+    if (NOT APPLE)
+      set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS} -s")  # --strip-unneeded for packaging
+      list(APPEND PROJECT_NAMES pcm-sensor-server)
+    endif()
     list(APPEND PROJECT_NAMES pcm-sensor)
-    if(LINUX)
-        list(APPEND PROJECT_NAMES pcm-sensor-server)
-    endif()
 
     # libpcm.a
     add_library(PCM_STATIC STATIC ${COMMON_SOURCES} ${UNUX_SOURCES})
@@ -92,7 +96,7 @@
      message(WARNING
            " ${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION} is incompartible with simdjson features' requirements.\n"
            " Refer to simdjson support matrix - https://github.com/simdjson/simdjson/blob/master/doc/basics.md .\n"
-           " Parsing events from 01.org/perfmon won't be supported.")
+           " Parsing events from https://github.com/intel/perfmon won't be supported.")
         set(SIMDJSON_IS_APPLICABLE FALSE)
 endif()
 
@@ -113,7 +117,9 @@
         else()
             message(WARNING
                 " ${CMAKE_CURRENT_SOURCE_DIR}/simdjson/singleheader/simdjson.h doesn't exist\n"
-                " Run 'git clone https://github.com/simdjson/simdjson.git' in 'src' directory to get simdjson library")
+                " Use `git clone --recursive` flag when cloning pcm repository to clone simdjson submodule as well or\n"
+                " update submodule with command 'git submodule update --init --recursive' or\n"
+                " run 'git clone https://github.com/simdjson/simdjson.git' in 'src' directory to get simdjson library")
         endif()
     endif(simdjson_FOUND)
 endif(SIMDJSON_IS_APPLICABLE)
@@ -132,6 +138,15 @@
     if(${PROJECT_NAME} STREQUAL pcm-raw)
         set(LIBS ${LIBS} PCM_SIMDJSON)
     endif(${PROJECT_NAME} STREQUAL pcm-raw)
+
+    if(${PROJECT_NAME} STREQUAL pcm-sensor-server)
+      file(READ pcm-sensor-server.service.in SENSOR_SERVICE_IN)
+      string(REPLACE "@@CMAKE_INSTALL_SBINDIR@@" "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_SBINDIR}" SENSOR_SERVICE "${SENSOR_SERVICE_IN}")
+      file(WRITE "${CMAKE_BINARY_DIR}/pcm-sensor-server.service" "${SENSOR_SERVICE}")
+      if(LINUX_SYSTEMD)
+        install(FILES "${CMAKE_BINARY_DIR}/pcm-sensor-server.service" DESTINATION "${LINUX_SYSTEMD_UNITDIR}")
+      endif(LINUX_SYSTEMD)
+    endif(${PROJECT_NAME} STREQUAL pcm-sensor-server)
 
     if(LINUX OR FREE_BSD)
         set(LIBS ${LIBS} Threads::Threads)
@@ -214,4 +229,8 @@
         COMMAND ${CMAKE_COMMAND} -E copy_directory
         "${PROJECT_SOURCE_DIR}/src/PMURegisterDeclarations"
         "$<TARGET_FILE_DIR:pcm-raw>/PMURegisterDeclarations")
+    add_custom_command(TARGET pcm-service POST_BUILD
+        COMMAND ${CMAKE_COMMAND} -E copy_if_different
+        "${PROJECT_SOURCE_DIR}/src/windows/pcm-service.exe.config"
+        $<TARGET_FILE_DIR:pcm-service>)
 endif(MSVC)
