=== debian/changelog ===
pcm (202302-1) unstable; urgency=medium

  * New upstream release.
  * No packaging updates to ease running the daemon/grafana/etc yet.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 21 Feb 2023 16:01:47 +0100

pcm (202212-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 23 Dec 2022 22:51:05 +0100

pcm (202211-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 24 Nov 2022 12:04:17 +0100

pcm (202210-1) unstable; urgency=medium

  * New upstream release.
  * Drop cmake fixups.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 19 Oct 2022 16:28:17 +0200
